Index: s390-tools-sles11/iucvterm/src/getopt.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/getopt.c
@@ -0,0 +1,226 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Processing of command line arguments
+ *
+ * Copyright IBM Corp. 2008, 2009
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <getopt.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "iucvterm/config.h"
+#include "iucvterm/gettext.h"
+#include "iucvterm/functions.h"
+
+#include "zt_common.h"
+
+
+static const char iucvtty_usage[] = N_(
+"Usage: %s [-h|--help] [-v|--version]\n"
+"       %s [-a <regex>] <terminal id>  [-- <login program> [<args>]]\n\n"
+"Options:\n"
+"  -h, --help           Print this help, then exit.\n"
+"  -v, --version        Print version information, then exit.\n"
+"  -a, --allow-from     Permit connections from particular z/VM guests only.\n"
+"                       A z/VM guest is permitted if regex matches its name.\n"
+);
+
+static const char iucvconn_usage[] = N_(
+"Usage: %s [-h|--help] [-v|--version]\n"
+"       %s [-e esc] [-s <file>] <vm guest> <terminal id>\n\n"
+"Options:\n"
+"  -h, --help           Print this help, then exit.\n"
+"  -v, --version        Print version information, then exit.\n"
+"  -s, --sessionlog     Write terminal session to file.\n"
+"  -e, --escape-char    Escape character (can be one of: A-Y, ], ^ or _)\n"
+"                       Characters C, D, Q, S, Z and [ are not allowed.\n"
+);
+
+static const struct option iucvterm_long_opts[] = {
+	{ "help",	  no_argument, NULL, 'h' },
+	{ "version",	  no_argument, NULL, 'v' },
+	{ "allow-from",	  required_argument, NULL, 'a' },
+	{ "sessionlog",   required_argument, NULL, 's' },
+	{ "escape-char",  required_argument, NULL, 'e' },
+	{  NULL,	  no_argument, NULL,  0  }
+};
+
+struct tool_info {
+	char		name[10];
+	char		optstring[10];
+	const char	*usage;
+	unsigned char	reqNonOpts;
+};
+
+/* program specific command line settings */
+static const struct tool_info iucv_tool[2] = {
+	{	.name = "iucvtty",
+		.optstring = "-hva:",
+		.usage = iucvtty_usage,
+		.reqNonOpts = 1,
+	},
+	{	.name = "iucvconn",
+		.optstring = "-hvs:e:",
+		.usage = iucvconn_usage,
+		.reqNonOpts = 2,
+	}
+};
+
+
+static void usage_exit(const struct tool_info *prg, int is_error,
+			const char *msg)
+{
+	if (msg != NULL)
+		fprintf(stderr, _("%s: %s\n"), prg->name, msg);
+	fprintf(stderr, _(prg->usage), prg->name, prg->name);
+	exit(is_error ? 1 : 0);	/* rc=1 .. invalid args */
+}
+
+static void version_exit(const struct tool_info *prg)
+{
+	printf(_("%s: IUCV Terminal Applications, version %s\n"),
+		prg->name, RELEASE_STRING);
+	printf(_("Copyright IBM Corp. 2008, 2009\n"));
+	exit(0);
+}
+
+static void cpy_or_exit(char *dest, const char *src, size_t size,
+			const struct tool_info *prg, const char *param)
+{
+	if (strlen(src) >= size){
+		fprintf(stderr,
+			_("%s: %s exceeds the maximum of %zu characters\n"),
+			prg->name, param, size - 1);
+		exit(1);
+	}
+	strncpy(dest, src, size);
+	dest[size - 1] = 0;
+}
+
+static void set_esc_or_exit(const struct tool_info *prg,
+	                    const char val, unsigned char *esc)
+{
+	unsigned char upval = toupper(val);
+
+	/* range of valid escape keys: A-Z [ \ ] ^ _ */
+	if (upval < 'A' || upval > '_')
+		usage_exit(prg, 1, _("The specified character is not a "
+				     "valid escape character"));
+
+	switch (upval) {
+	case 'C':	/* interrupt (ISIG) */
+	case 'D':	/* EoF / EoT */
+	case 'Q':	/* XON */
+	case 'S':	/* XOFF */
+	case 'Z':	/* suspend (shell) */
+	case '[':	/* ESC */
+		usage_exit(prg, 1, _("The specified character is not a "
+				     "valid escape character"));
+	default:
+		*esc = upval ^ 0100;	/* see ascii(7) */
+		break;
+	}
+}
+
+
+void parse_options(enum iucvterm_prg prg, struct iucvtty_cfg *config,
+		   int argc, char **argv)
+{
+	int c;
+	int index;
+	int nonOpts = 0;
+
+	config->cmd_parms = NULL;
+	config->client_check = 0;
+	config->sessionlog = NULL;
+	config->esc_char = '_' ^ 0100;		/* Ctrl-_ (0x1f) */
+
+	while (1) {
+		index = -1;
+		c = getopt_long(argc, argv, iucv_tool[prg].optstring,
+				iucvterm_long_opts, &index);
+		if (c == -1)
+			break;
+
+		switch (c) {
+		case 1:
+			if (nonOpts >= iucv_tool[prg].reqNonOpts) {
+				usage_exit(&iucv_tool[prg], 1, NULL);
+				break;
+			}
+			switch (nonOpts) {
+			case 0:
+				if (prg == PROG_IUCV_CONN)
+					cpy_or_exit(config->host, optarg,
+						    sizeof(config->host),
+						    &iucv_tool[prg],
+						    _("<vm guest>"));
+				else
+					cpy_or_exit(config->service, optarg,
+						    sizeof(config->service),
+						    &iucv_tool[prg],
+						    _("<terminal id>"));
+				break;
+			case 1:
+				cpy_or_exit(config->service, optarg,
+					    sizeof(config->service),
+					    &iucv_tool[prg],
+					    _("<terminal id>"));
+				break;
+			default:
+				usage_exit(&iucv_tool[prg], 1, NULL);
+				break;
+			}
+			++nonOpts;
+			break;
+		case 'a':/* max 80 */
+			cpy_or_exit(config->client_re, optarg,
+				    sizeof(config->client_re),
+				    &iucv_tool[prg], _("<regex>"));
+			if (is_regex_valid(config->client_re))
+				exit(1);
+			config->client_check  = 1;
+			break;
+		case 'e':
+			switch (strlen(optarg)) {
+			case 1:
+				set_esc_or_exit(&iucv_tool[prg], optarg[0],
+					        &config->esc_char);
+				break;
+			case 4:
+				if (memcmp(optarg, "none", 4) == 0) {
+					config->esc_char = 0;
+					break;
+				}
+				/* fall through */
+			default:
+				usage_exit(&iucv_tool[prg], 1,
+					   _("The escape character must be a "
+					     "single character or 'none'"));
+			}
+			break;
+		case 's':
+			config->sessionlog = optarg;
+			break;
+		case 'h':
+			usage_exit(&iucv_tool[prg], 0, NULL);
+		case 'v':
+			version_exit(&iucv_tool[prg]);
+		case '?':
+			printf(_("Try '%s --help' for more information.\n"),
+				iucv_tool[prg].name);
+			exit(1);
+			break;
+		}
+	}
+
+	if (optind < argc)	/* save additional parameters */
+		config->cmd_parms = argv + optind;
+
+	if (nonOpts < iucv_tool[prg].reqNonOpts)	/* not enough args */
+		usage_exit(&iucv_tool[prg], 1,
+			_("The command does not have enough arguments"));
+}
Index: s390-tools-sles11/iucvterm/src/iucvconn.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/iucvconn.c
@@ -0,0 +1,349 @@
+/*
+ * iucvconn - Application that establishes a terminal connection over IUCV
+ *
+ * Core application
+ *
+ * Copyright IBM Corp. 2008, 2009
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <errno.h>
+#include <pwd.h>
+#include <signal.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <syslog.h>
+#include <termios.h>
+#include <unistd.h>
+
+#include "iucvterm/gettext.h"
+#include "iucvterm/config.h"
+#include "iucvterm/functions.h"
+
+
+#define SYSLOG_IDENT		"iucvconn"
+#define PRG_COMPONENT		SYSLOG_IDENT
+#define DEFAULT_TERM		"linux"
+
+#define AUDIT(f, ...)		do { \
+					syslog(LOG_INFO, (f), __VA_ARGS__); \
+					write_session_info((f), __VA_ARGS__); \
+				} while (0);
+
+/* escape mode actions */
+enum esc_action_t {
+	DISCONNECT,		/* Disconnect from terminal   */
+	RESIZE,			/* Force terminal resizing    */
+	SEND,			/* Send data (default action) */
+	IGNORE,			/* Ignore escape character   */
+};
+
+
+static volatile sig_atomic_t resize_tty;
+static struct termios ios_orig;		/* store original termio settings */
+
+
+/**
+ * sig_handler() - Signal handler
+ * @sig:	Signal number
+ */
+static void sig_handler(int sig)
+{
+	switch (sig) {
+	case SIGWINCH:
+		resize_tty = sig;
+		break;
+
+	case SIGTERM:
+		tcsetattr(STDIN_FILENO, TCSANOW, &ios_orig);
+		close_session_log();
+		_exit(0);
+		break;
+	}
+}
+
+/**
+ * get_msg_char() - Returns single character from message
+ * @msg:	The IUCV terminal message
+ *
+ * Returns the (single) character of an IUCV terminal message
+ * if @msg is of type MSG_TYPE_DATA and contains a single character
+ * (datalen == 1). Otherwise the routine returns zero.
+ */
+static unsigned char get_msg_char(const struct iucvtty_msg *msg)
+{
+	if (msg->type != MSG_TYPE_DATA || msg->datalen != 1)
+		return 0;
+
+	return msg->data[0];
+}
+
+/**
+ * is_esc_char() - Check message for escape character
+ * @msg:	The IUCV terminal message
+ * @esc:	The escape character
+ *
+ * Returns 1 if @msg contains the escape charater @esc only; otherwise the
+ * function returns 0.
+ */
+static int is_esc_char(const struct iucvtty_msg *msg, unsigned char esc)
+{
+	if (!esc)
+		return 0;
+
+	return (get_msg_char(msg) == esc) ? 1 : 0;
+}
+
+/**
+ * get_action() - Returns the action from an escaped character
+ * @msg:	The IUCV terminal message
+ * @esc:	The escape character
+ *
+ * Returns the appropriate action of the escaped charater.
+ * The action is derived from the single character stored in the IUCV terminal
+ * message @msg. If the escape character is recognized, SEND is returned for
+ * sending the "escaped" escape character to the terminal.
+ *
+ * If it contains multiple characters, the default SEND action is used to
+ * indicate that the escape mode is done and to force sending the complete data
+ * characters (e.g. entered by copy & paste).
+ *
+ * NOTE: This routine must be called in "escape mode".
+ */
+static enum esc_action_t get_action(const struct iucvtty_msg *msg,
+				    unsigned char esc)
+{
+	if (is_esc_char(msg, esc))
+		return SEND;
+
+	switch (get_msg_char(msg)) {
+	case   0:
+		return SEND;
+	case '.':
+	case 'd':
+		return DISCONNECT;
+	case 'r':
+		return RESIZE;
+	default:
+		return IGNORE;
+	}
+}
+
+/**
+ * iucvtty_worker() - Handle server connection
+ * @terminal:	IUCV TTY server file descriptor
+ */
+static int iucvtty_worker(int terminal, const struct iucvtty_cfg *cfg)
+{
+	struct iucvtty_msg *msg;
+	fd_set set;
+	size_t chunk;
+	int in_esc_mode;
+	enum esc_action_t action;
+
+	/* setup buffers */
+	msg = malloc(MSG_BUFFER_SIZE);
+	if (msg == NULL) {
+		print_error("Allocating memory for the data buffer failed");
+		return -1;
+	}
+
+	/* multiplex i/o between login program and socket */
+	chunk = 0;
+	in_esc_mode = 0;	/* escape mode state */
+	action = SEND;
+	while (1) {
+		if (resize_tty) {
+			iucvtty_tx_winsize(terminal, STDIN_FILENO);
+			resize_tty = 0;	/* clear signal flag */
+		}
+
+		FD_ZERO(&set);
+		FD_SET(terminal, &set);
+		FD_SET(STDIN_FILENO, &set);
+
+		if (select(max(STDIN_FILENO, terminal) + 1, &set,
+				 NULL, NULL, NULL) == -1) {
+			if (errno == EINTR)
+				continue;
+			break;
+		}
+
+		if (FD_ISSET(terminal, &set)) {
+			if (iucvtty_read_msg(terminal, msg,
+					     MSG_BUFFER_SIZE, &chunk))
+				break;
+
+			switch (msg->type) {
+			case MSG_TYPE_DATA:
+				iucvtty_copy_data(STDOUT_FILENO, msg);
+				write_session_log(msg->data, msg->datalen);
+				break;
+			case MSG_TYPE_ERROR:
+				iucvtty_error(*(uint32_t *) msg->data);
+				break;
+			}
+		}
+
+		if (FD_ISSET(STDIN_FILENO, &set)) {
+			if (iucvtty_read_data(STDIN_FILENO, msg,
+					      MSG_BUFFER_SIZE))
+				break;
+
+			if (in_esc_mode) {
+				in_esc_mode = 0;	/* reset */
+				action = get_action(msg, cfg->esc_char);
+			} else {
+				if (is_esc_char(msg, cfg->esc_char)) {
+					in_esc_mode = 1;
+					action = IGNORE;
+				} else
+					action = SEND;
+			}
+
+			/* handle escape mode */
+			switch (action) {
+			case SEND:	/* non-escape mode (default) */
+				if (iucvtty_write_msg(terminal, msg))
+					goto out_worker_loop;
+				break;
+
+			case DISCONNECT:/* disconnect  */
+				goto out_worker_loop;
+
+			case RESIZE: 	/* force terminal resize */
+				iucvtty_tx_winsize(terminal, STDIN_FILENO);
+				break;
+
+			case IGNORE:
+				break;
+			}
+		}
+	}
+
+out_worker_loop:
+	free(msg);
+	return 0;
+}
+
+/**
+ * main() - IUCV CONN program startup
+ */
+int main(int argc, char *argv[])
+{
+	int			rc;
+	int 			server;
+	struct sockaddr_iucv	addr;
+	struct termios		ios;
+	struct sigaction	sigact;
+	struct passwd		*passwd;
+	struct iucvtty_cfg	conf;
+
+
+	/* gettext initialization */
+	gettext_init();
+
+	/* parse command line options */
+	parse_options(PROG_IUCV_CONN, &conf, argc, argv);
+
+	/* open session audit log */
+	if (conf.sessionlog != NULL)
+		if (open_session_log(conf.sessionlog)) {
+			print_error("Creating the terminal session "
+				    "log files failed");
+			return 1;
+		}
+
+	/* open socket and connect to server */
+	server = iucvtty_socket(&addr, conf.host, conf.service);
+	if (server == -1) {
+		print_error((errno == EAFNOSUPPORT)
+			    ? N_("The AF_IUCV address family is not available")
+			    : N_("Creating the AF_IUCV socket failed"));
+		return 1;
+	}
+
+	/* syslog */
+	openlog(SYSLOG_IDENT, LOG_PID, LOG_AUTHPRIV);
+
+	/* get user information for syslog */
+	passwd = getpwuid(geteuid());
+
+	if (connect(server, (struct sockaddr *) &addr, sizeof(addr)) == -1) {
+		switch (errno) {
+		case EAGAIN:
+			print_error("The new connection would exceed the "
+				    "maximum number of IUCV connections");
+			break;
+		case ENETUNREACH:
+			print_error("The target z/VM guest virtual machine "
+				    "is not logged on");
+			break;
+		case EACCES:
+			print_error("The IUCV authorizations do not permit "
+				    "connecting to the target z/VM guest");
+			break;
+		default:
+			print_error("Connecting to the z/VM guest virtual "
+				    "machine failed");
+			break;
+		}
+		AUDIT("Connection to %s/%s failed for user %s (uid=%i)",
+			conf.host, conf.service,
+			(passwd != NULL) ? passwd->pw_name : "n/a", geteuid());
+		rc = 2;
+		goto return_on_error;
+	}
+	AUDIT("Established connection to %s/%s for user %s (uid=%i)",
+		conf.host, conf.service,
+		(passwd != NULL) ? passwd->pw_name : "n/a", geteuid());
+
+	/* send client params */
+	iucvtty_tx_termenv(server, DEFAULT_TERM);
+	iucvtty_tx_winsize(server, STDIN_FILENO);
+
+	/* register signal handler */
+	sigemptyset(&sigact.sa_mask);
+	sigact.sa_flags = SA_RESTART;
+	sigact.sa_handler = sig_handler;
+	sigaction(SIGWINCH, &sigact, NULL);
+	sigaction(SIGTERM,  &sigact, NULL);
+
+	/* modify terminal settings */
+	if (tcgetattr(STDIN_FILENO, &ios_orig)) {
+		print_error("Getting the terminal I/O settings failed");
+		rc = 3;
+		goto return_on_error;
+	}
+	memcpy(&ios, &ios_orig, sizeof(ios));
+
+	/* put terminal into raw mode */
+	cfmakeraw(&ios);
+	/* NOTE: If the tty driver (ldisc) runs in TTY_DRIVER_REAL_RAW,
+	 *       we need to do the input character processing here;
+	 *       that means to translate CR into CR + NL (ICRNL).
+	 * Define TTY_REAL_RAW in for that case. */
+#ifdef TTY_REAL_RAW
+	ios.c_iflag |= ICRNL;			/* | IGNPAR | IGNBRK; */
+#endif
+	tcflush(STDIN_FILENO, TCIOFLUSH);
+	if (tcsetattr(STDIN_FILENO, TCSANOW, &ios)) {
+		print_error("Modifying the terminal I/O settings failed");
+		rc = 4;
+		goto return_on_error;
+	}
+
+	iucvtty_worker(server, &conf);
+
+	tcsetattr(STDIN_FILENO, TCSANOW, &ios_orig);
+
+	rc = 0;
+return_on_error:
+	close(server);
+	closelog();
+	close_session_log();
+
+	return rc;
+}
Index: s390-tools-sles11/iucvterm/src/iucvtty.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/iucvtty.c
@@ -0,0 +1,292 @@
+/*
+ * iucvtty - Application that provides a full-screen terminal for iucvconn
+ *
+ * Core application
+ *
+ * Copyright IBM Corp. 2008, 2009
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <errno.h>
+#include <fcntl.h>
+#include <pty.h>
+#include <signal.h>
+#include <sys/types.h>
+#include <sys/select.h>
+#include <sys/socket.h>
+#include <sys/wait.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <utmp.h>
+
+#include "iucvterm/config.h"
+#include "iucvterm/gettext.h"
+#include "iucvterm/functions.h"
+#include "af_iucv.h"
+
+
+#define SYSLOG_IDENT		"iucvtty"
+#define PRG_COMPONENT           SYSLOG_IDENT
+#define TERM_BUFSIZE		256
+#define TERM_DEFAULT		"linux"
+
+
+static volatile sig_atomic_t sig_shutdown;
+
+
+/**
+ * sig_handler() - Signal handler
+ * @sig:	Signal number.
+ */
+static void sig_handler(int sig)
+{
+	sig_shutdown = sig;
+}
+
+/**
+ * exec_login_prog() - execute a login program
+ * @cmd:	Path to the (login) program executable
+ * @host:	Originator host that is passed to /bin/login
+ */
+static int exec_login_prog(char *cmd[], const char *host)
+{
+	int rc;
+
+	if (cmd != NULL)
+		rc = execv(cmd[0], cmd);
+	else
+		/* for root only: write hostname to [uw]tmp if set */
+		if (geteuid() == 0 && host != NULL)
+			rc = execl("/bin/login", "/bin/login", "-h", host,
+					(char *) NULL);
+		else
+			rc = execl("/bin/login", "/bin/login", (char *) NULL);
+	return rc;
+}
+
+/**
+ * iucvtty_worker() - Handle an incoming client connection
+ * @client:	Client file descriptor
+ * @master:	PTY master file descriptor
+ * @slave:	PTY slave file descriptor
+ * @host:	Originator z/VM guest virtual machine
+ * @cfg:	IUCV TTY configuration structure.
+ */
+static int iucvtty_worker(int client, int master, int slave,
+			  const char *host, const struct iucvtty_cfg *cfg)
+{
+	int rc;
+	struct iucvtty_msg *msg;
+	pid_t child;
+	fd_set set;
+	size_t chunk;
+	char term_env[TERM_BUFSIZE];
+
+
+	/* flush pending terminal data */
+	tcflush(master, TCIOFLUSH);
+
+	/* read terminal parameters from client */
+	if (iucvtty_rx_termenv(client, term_env, TERM_BUFSIZE))
+		sprintf(term_env, TERM_DEFAULT);
+
+	/* start login program */
+	child = fork();
+	if (child == -1) {
+		print_error("Creating a new process to run the "
+			    "login program failed");
+		iucvtty_tx_error(client, ERR_FORK);
+		return 1;	/* return from worker */
+	}
+	if (child == 0) {	/* child process */
+		closelog();	/* close syslog */
+
+		/* setup terminal */
+		if (login_tty(slave)) {
+			print_error("Setting up a terminal for user login failed");
+			iucvtty_tx_error(client, ERR_SETUP_LOGIN_TTY);
+			exit(2);
+		}
+		setenv("TERM", term_env, 1);
+		if (exec_login_prog(cfg->cmd_parms, host)) {
+			print_error("Running the login program failed");
+			iucvtty_tx_error(client, ERR_CANNOT_EXEC_LOGIN);
+		}
+		exit(3);	/* we only reach here if exec has failed */
+	}
+
+	/* setup buffers */
+	msg = malloc(MSG_BUFFER_SIZE);
+	if (msg == NULL) {
+		print_error("Allocating memory for the data buffer failed");
+		rc = 2;
+		goto out_kill_login;
+	}
+
+	/* multiplex i/o between login program and socket. */
+	rc = 0;
+	chunk = 0;
+	while (!sig_shutdown) {
+		FD_ZERO(&set);
+		FD_SET(client, &set);
+		FD_SET(master, &set);
+
+		if (select(max(master, client) + 1, &set,
+			   NULL, NULL, NULL) == -1) {
+			if (errno == EINTR)
+				continue;
+			break;
+		}
+
+		if (FD_ISSET(client, &set)) {
+			if (iucvtty_read_msg(client, msg,
+					     MSG_BUFFER_SIZE, &chunk))
+				break;
+			switch (msg->type) {
+			case MSG_TYPE_DATA:
+				iucvtty_copy_data(master, msg);
+				break;
+			case MSG_TYPE_WINSIZE:
+				if (msg->datalen != sizeof(struct winsize))
+					break;
+				if (ioctl(master, TIOCSWINSZ,
+					  (struct winsize *) msg->data))
+					print_error("Resizing the terminal "
+						    "window failed");
+				break;
+			case MSG_TYPE_TERMIOS:	/* ignored */
+				break;
+			case MSG_TYPE_ERROR:
+				iucvtty_error(*(uint32_t *) msg->data);
+				break;
+			}
+		}
+
+		if (FD_ISSET(master, &set))
+			if (iucvtty_tx_data(client, master,
+					    msg, MSG_BUFFER_SIZE))
+				break;
+	}
+	free(msg);
+
+out_kill_login:
+	/* ensure the chld is terminated before calling waitpid:
+	 * - in case a sigterm has been received,
+	 * - or a sigchld from other than the chld
+	 */
+	kill(child, SIGKILL);	/* cause a sigchld */
+	waitpid(child, NULL, 0);
+
+	return rc;
+}
+
+/**
+ * main() - IUCV TTY program startup
+ */
+int main(int argc, char *argv[])
+{
+	struct iucvtty_cfg	conf;		/* program configuration */
+	struct sockaddr_iucv	saddr, caddr;	/* IUCV socket address info */
+	char 			client_host[9];	/* client guest name */
+	int 			server, client;	/* socket file descriptors */
+	int 			master, slave;	/* pre-allocated PTY fds */
+	struct sigaction	sigact;		/* signal handler */
+	int 			rc;
+	socklen_t		len;
+
+
+	/* gettext initialization */
+	gettext_init();
+
+	/* parse command line arguments */
+	parse_options(PROG_IUCV_TTY, &conf, argc, argv);
+
+	/* create server socket... */
+	server = iucvtty_socket(&saddr, NULL, conf.service);
+	if (server == -1) {
+		print_error((errno == EAFNOSUPPORT)
+			    ? N_("The AF_IUCV address family is not available")
+			    : N_("Creating the AF_IUCV socket failed"));
+		return 1;
+	}
+	if (bind(server, (struct sockaddr *) &saddr, sizeof(saddr)) == -1) {
+		print_error("Binding the AF_IUCV socket failed");
+		close(server);
+		return 1;
+	}
+	if (listen(server, 1) == -1) {
+		print_error("Listening for incoming connections failed");
+		close(server);
+		return 1;
+	}
+
+	/* pre-allocate PTY master/slave file descriptors */
+	if (openpty(&master, &slave, NULL, NULL, NULL)) {
+		print_error("Opening a new PTY master/slave device pair failed");
+		close(server);
+		return 1;
+	}
+
+	/* set close-on-exec for file descriptors */
+	fcntl(master, F_SETFD, FD_CLOEXEC);
+	fcntl(server, F_SETFD, FD_CLOEXEC);
+
+	/* syslog */
+	openlog(SYSLOG_IDENT, LOG_PID, LOG_AUTHPRIV);
+	syslog(LOG_INFO, "Listening on terminal ID: %s, using pts device: %s",
+		conf.service, ttyname(slave));
+
+	rc = 0;
+	len = sizeof(struct sockaddr_iucv);
+	/* accept a new client connection */
+	client = accept(server, (struct sockaddr *) &caddr, &len);
+	if (client == -1) {
+		print_error("An incoming connection could not be accepted");
+		rc = 2;
+		goto exit_on_error;
+	}
+
+	/* check if client is allowed to connect */
+	userid_cpy(client_host, caddr.siucv_user_id);
+	if (is_client_allowed(client_host, &conf)) {
+		iucvtty_tx_error(client, ERR_NOT_AUTHORIZED);
+		syslog(LOG_WARNING, "Rejected client connection from %s; "
+				    "Client is not allowed to connect.",
+				    client_host);
+		rc = 3;
+
+	} else { /* client is allowed to connect */
+		syslog(LOG_INFO, "Accepted client connection from %s",
+			client_host);
+		/* set close-on-exec for client socket */
+		fcntl(client, F_SETFD, FD_CLOEXEC);
+		/* close server socket */
+		close(server);
+
+		/* setup signal handler to notify shutdown signal */
+		sigemptyset(&sigact.sa_mask);
+		sigact.sa_flags = SA_RESTART;
+		sigact.sa_handler = sig_handler;
+		if (sigaction(SIGCHLD, &sigact, NULL)
+			|| sigaction(SIGTERM, &sigact, NULL)
+			|| sigaction(SIGPIPE, &sigact, NULL)) {
+			print_error("Registering a signal handler failed");
+			rc = 4;
+			goto exit_on_error;
+		}
+
+		/* handle client terminal connection */
+		rc = iucvtty_worker(client, master, slave, client_host, &conf);
+	}
+
+	close(client);
+
+exit_on_error:
+	close(slave);
+	close(master);
+	closelog();
+
+	return rc;
+}
Index: s390-tools-sles11/iucvterm/test/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/Makefile
@@ -0,0 +1,40 @@
+#! /usr/bin/make -f
+
+include ../../common.mak
+
+
+CPPFLAGS += -I../include
+CFLAGS   += -g
+
+
+PROGRAMS = test_afiucv
+TEST_PROGRAMS = test_functions test_allow
+TEST_PROGRAMS_NORUN = test_auditlog
+
+
+test_afiucv: test_afiucv.o
+test_functions: test_functions.o test_common.o ../src/functions.o
+test_allow: test_allow.o test_common.o ../src/functions.o
+test_auditlog: test_auditlog.o test_common.o ../src/auditlog.o ../src/functions.o
+
+
+all: $(PROGRAMS)
+check: $(TEST_PROGRAMS) $(TEST_PROGRAMS_NORUN)
+	@for prg in $(TEST_PROGRAMS); do \
+		failed=0 ;\
+		echo ; echo "=== RUN : $$prg ===" ;\
+		./$$prg || failed=$$? ;\
+		if test x$$failed = x0; then \
+			echo "=== PASS: $$prg ===" ;\
+		else \
+			echo "=== FAIL: $$prg (rc=$$failed) ===" ;\
+		fi ;\
+	done
+
+install:
+
+clean:
+	-rm -f *.o $(PROGRAMS) $(TEST_PROGRAMS) $(TEST_PROGRAMS_NORUN)
+
+
+.PHONY: install clean
Index: s390-tools-sles11/iucvterm/test/test.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test.h
@@ -0,0 +1,24 @@
+/*
+ * test_common - Test program for the IUCV Terminal Applications
+ *
+ * Definition of common functions for test programs
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#ifndef __TEST_H_
+#define __TEST_H_
+
+
+#include <assert.h>
+#include <stdlib.h>
+#include "iucvterm/proto.h"
+
+
+#define __fail()	assert(0);
+
+
+extern int __socketpair(int sv[2]);
+extern int __msgcmp(const struct iucvtty_msg *, const struct iucvtty_msg *);
+
+#endif /* __TEST_H_ */
Index: s390-tools-sles11/iucvterm/test/test_afiucv.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test_afiucv.c
@@ -0,0 +1,30 @@
+/*
+ * test_afiucv - Test program for the IUCV Terminal Applications
+ *
+ * Test program to check if the AF_IUCV family is supported by
+ * the running Linux kernel
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <errno.h>
+#include <stdio.h>
+#include <sys/socket.h>
+#include <unistd.h>
+#include "af_iucv.h"
+
+
+int main(void)
+{
+	int sk;
+
+	sk = socket(AF_IUCV, SOCK_STREAM, 0);
+	if (sk == -1) {
+		if (errno == EAFNOSUPPORT)
+			perror("AF_IUCV address family not supported");
+		return -1;
+	} else
+		close(sk);
+
+	return 0;
+}
Index: s390-tools-sles11/iucvterm/test/test_allow.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test_allow.c
@@ -0,0 +1,77 @@
+/*
+ * test_allow - Test program for the IUCV Terminal Applications
+ *
+ * Test program to check common functions that use the regex api
+ *
+ * Copyright IBM Corp. 2008, 2009
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <stdio.h>
+#include <unistd.h>
+#include "test.h"
+
+#include "iucvterm/config.h"
+#include "iucvterm/functions.h"
+
+
+static int test_userid_cpy(char padded[9])
+{
+	char uid[8];
+	char id_str[9];
+	size_t len;
+
+	memcpy(uid, padded, 8);
+	userid_cpy(id_str, uid);
+
+	len = strlen(id_str);
+	assert(0 == memcmp(padded, id_str, len));
+
+	if (strchr(id_str, ' ') != NULL)
+		__fail();
+
+	return len;
+}
+
+int main(void)
+{
+	char re_ok[]    = "^T63[[:digit:]]{1,5}$";
+	char re_wrong[] = "^t63[[:alpha:]+$";
+	char re_short[] = "^lnx[[:digit:]]{3}$";
+	char id_short[9];
+	char user_id[8];
+
+	/* redirect stderr to /dev/null to avoid regex error output */
+	freopen("/dev/null", "w", stderr);
+
+	assert(-1 == is_regex_valid(re_wrong));
+	assert(-1 == is_regex_valid(NULL));
+	assert(0  == is_regex_valid(re_ok));
+	assert(0  == is_regex_valid(re_short));
+
+	/* simple */
+	assert(0 == strmatch("T6345050", "T6345050"));
+	/* using re */
+	assert(0 == strmatch("T6345050", re_ok));
+	assert(0 == strmatch("t6345050", re_ok)); /* icase */
+	assert(-1 == strmatch("T6345050", NULL));
+	assert(-1 == strmatch("T6345050", re_wrong));
+	assert(1 == strmatch("T634505A", re_ok));
+
+	/* test userid_cpy() function */
+	snprintf(id_short, 9, "%-8s", "");
+	assert(0 == test_userid_cpy(id_short));
+	snprintf(id_short, 9, "1");
+	assert(1 == test_userid_cpy(id_short));
+	snprintf(id_short, 9, "12345678");
+	assert(8 == test_userid_cpy(id_short));
+	snprintf(id_short, 9, "ABCD");
+	assert(4 == test_userid_cpy(id_short));
+
+	/* check for user IDs < 8 characters */
+	snprintf(id_short, 9, "%-8s", "LNX001");
+	memcpy(user_id, id_short, 8);
+	userid_cpy(id_short, user_id);
+	assert(0 == strmatch(id_short, re_short));
+
+	return 0;
+}
Index: s390-tools-sles11/iucvterm/test/test_auditlog.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test_auditlog.c
@@ -0,0 +1,76 @@
+/*
+ * test_auditlog - Test program for the IUCV Terminal Applications
+ *
+ * Test program for the session logging functions used by iucvconn(1).
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/select.h>
+#include <unistd.h>
+#include "iucvterm/functions.h"
+#include "test.h"
+
+#define BUF_SIZE 1024
+
+
+static void do_cleanup(const char *filename)
+{
+	char tmp[64];
+
+	if (access(filename, W_OK) == 0)
+		unlink(filename);
+
+	snprintf(tmp, 64, "%s.timing", filename);
+	if (access(tmp, W_OK) == 0)
+		unlink(tmp);
+
+	snprintf(tmp, 64, "%s.info", filename);
+	if (access(tmp, W_OK) == 0)
+		unlink(tmp);
+}
+
+int main(int argc, char* argv[]){
+
+	char *filepath = NULL;
+	char *buf;
+	char  tmpfile[64];
+	int   interactive;
+	ssize_t rc;
+
+
+	if (argc < 2) {
+		fprintf(stderr, "Usage: %s <filepath>\n", argv[0]);
+		sprintf(tmpfile, "/tmp/test_auditlog.a1b2c3.%u", getpid());
+		fprintf(stderr, "now using file %s\n", tmpfile);
+		filepath = tmpfile;
+		/* cleanup stale file */
+		if (access(tmpfile, W_OK) == 0)
+			do_cleanup(tmpfile);
+		interactive = 0;
+	} else {
+		interactive = 1;
+		filepath = argv[1];
+	}
+	buf = malloc(BUF_SIZE);
+
+	rc = open_session_log(filepath);
+	assert(rc == 0);
+
+	write_session_info("The name of the log file is: %s\n", filepath);
+
+	sprintf(buf, "This is an entry\n");
+	rc = write_session_log(buf, strlen(buf));
+	assert(rc == 0);
+
+	close_session_log();
+
+	free(buf);
+	if (!interactive)
+		do_cleanup(tmpfile);
+	return 0;
+}
Index: s390-tools-sles11/iucvterm/test/test_common.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test_common.c
@@ -0,0 +1,40 @@
+/*
+ * test_common library - Test program lib for the IUCV Terminal Applications
+ *
+ * Common functions for test programs
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <assert.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+
+#include "iucvterm/proto.h"
+
+
+int __socketpair(int sv[2])
+{
+	int rc;
+
+	rc = socketpair(AF_LOCAL, SOCK_STREAM, 0, sv);
+	if (rc)
+		perror("Could not create socketpair");
+
+	assert(rc == 0);
+	return rc;
+}
+
+int __msgcmp(const struct iucvtty_msg *m1, const struct iucvtty_msg *m2)
+{
+	if (m1->type != m2->type)
+		return 1;
+	if (m1->datalen != m2->datalen)
+		return 2;
+	if (0 != memcmp(m1->data, m2->data, m1->datalen))
+		return 3;
+	return 0;
+}
